// ----- LCD 4bit komunikace ver. 14.8.1 

#include <xc.h>
#include "LCD_HD44780_4bit.h"

char str1[], str2[];  //pole pro radek 1 a 2

void LCD_Start(char ch) {
    char port;
    port = PORTB & 0x0F;
    port | = ch<<4;
    PORTB = port;
    EN = 0;
    EN = 1;
    if (ch == 3) Sdelay(125); else Sdelay(1);
}

void LCD_Init(void) {
    Delay(5);
   // __delay_ms(40);
    TRISB&= 0x0F;
    EN = 1;
    RS = 0;
    LCD_Start(3); //?ekej > 4,1ms
    LCD_Start(3);
    LCD_Start(3);
    LCD_Start(2);

    LCD_Chr(0x28, CMD); //dva rdky
    LCD_Chr(0x10, CMD); //smazat LCD
    LCD_Chr(0x0E, CMD); //zapni LCD
    LCD_Chr(0x06, CMD); //incrementace
    LCD_Chr(0x01, CMD);
    TRISB|= 0xF0;
}



void LCD_Chr(char chr, char dc)
{
  //  EN = 1;
      if(dc && (chr == '')) chr = 0xDF;  //krouzek
    RS = dc; //RS = 1(data)
    PORTB &= 0x0F;
    PORTB| = chr & 0xF0;
    EN = 1;
    EN = 0;
    PORTB &= 0x0F;
    PORTB |= (chr & 0x0F)<<4;
    EN = 1;
    EN = 0;
    if ((chr < 4) && dc == CMD) Sdelay(62); // __delay_ms(2);
    else Sdelay(1); //32us
    EN = 1;
   
}

//inicializace LCD
/* void CPU_Init(void)
{
    PORTB = 0;
    PORTA = 0;
    TCS = 1;
    TRISA = 0xA4;
    TRISB = 0xF2;
    CMCON = 0x07;
 //   T0IE = 0;
    
 
    OPTION_REG = 0x06;  // internal clk, presc. 128

 /*    T2CKPS1 = 1; //presc 16
    TOUTPS0 = 1; //postsc. 1:10
    TOUTPS1 = 0;
    TOUTPS2 = 0;
    TOUTPS3 = 1;
    TMR2ON = 1;
   T2CON = 0x4E;   //01001110
   PR2 = 249;
    CCP1CON = 0x0C;
    CCPR1L = 0; // zhasnout
     VRCON = 0; // vref = 0
    TMR2IE = 1;
    INTCON=0xC0;*/
 //   PEIE = 1;
 //   GIE = 1;
 //   ADCON0 = 0x10; // AN4 - RC0
  //  ADCON1 = 0x20; // ADC clock Fosc/32
 //  ADFM = 1;  // vpravo

  // }
   //*/
/*
void LCD_Str(const char *str)
{
 // unsigned char x = 0;
    while(*str!=0)
    {
	LCD_Chr(*str++, DAT);
	//x++;
    }
}
*/
/*
void LCD_Strx(char x)
{   char *str;
char cx = 0x80;
    TRISB&= 0x0F;
    if(x==1){
    str = str1;    
    }
    else {
      str = str2; cx = 0xC0;     
    }
    LCD_Chr(cx, CMD);
    while(*str!=0)
        LCD_Chr(*str++, DT);

    TRISB|= 0xF0;
    
}*/

void LCD_Strx(char cx)
{   char *str;
//char cx = 0x80;
    TRISB&= 0x0F;
  if(cx==0x80){
    str = str1;
    }
    else {
      str = str2;
    }
    LCD_Chr(cx, CMD);
    while(*str!=0)
        LCD_Chr(*str++, DT);

    TRISB|= 0xF0;

}


/*
//Nastaven ukazatele na pozici x,y
void LCD_Gxy(unsigned char row,unsigned char col)
{   TRISB&= 0x0F;
    switch(row)
    {
        case 1:row=0x00;break;
        case 2:row=0x40;break;
    }
    LCD_Chr(0x80 | row | col, CMD);
    TRISB|= 0xF0;
}
*/
/*
void TxRxInit(void) {
    TXEN = 0;
    CREN = 1;
    SYNC = 0;
    SPEN = 1;
    SPBRG = 207;  // pro 4MHz 51;
    RCIE = 1;
    
}*/