/* Disp648 - LCD 1602 - RS485 ver. 14.8.1 */
/* Pavel Dvok 2013 - 2015*/
/* XC8 v1.31*/

 #define LM
 #define DS
 #define BAT
//#define PNP

#include <xc.h>
#include "LCD_HD44780_4bit.h"
#include <stdlib.h>

#pragma   config FOSC = ECIO,  MCLRE = OFF
#pragma   config PWRTE = ON, BOREN = OFF
#pragma   config  WDTE = ON
#pragma   config  LVP = OFF
#pragma   config  CP = OFF
#pragma   config   CPD = OFF

#define   SCLK  PORTBbits.RB4    //clk pro DS1302
#define   DAT   PORTBbits.RB5    //IO pro DS1302
#define   CEN   PORTBbits.RB0    //1=EN pro DS1302 
#define   FEN   PORTAbits.RA4    //0=EN FreqCnt   
#define   TCS   PORTAbits.RA0      //EN pro TC77
#define   TCLK  PORTBbits.RB7      //clk pro TC77
#define   TDAT  PORTBbits.RB6      //IO pro TC77
#define   EB    120            //EEPROM pole pro status a parametry  
#define   ETXT  128             //EEPROM pole pro uloen 2. dku

char timstr[8];
char alarm[4];
char str2[24];
char str1[24];
char strt[40];
char tstr[8];
unsigned long tmrup=0;
unsigned int tup=0;
char px=0;
char sw = 0; // dipsw mod
char tms=0, tf = 0;
char tsec=0;
char prewr=0;
char menu=0,  soh=0 ;
char etx=0, bsw=0, rec=0;
char adr;
char estat;
char baud;
char ledlev;
char par;
char vref;
char disp;
char but;
char rx;
char ssc;
char tflg;
char astp = 0;
char mes=0;
char ack[2];

//teplota estat & 1, freq estat & 2, ledon estat & 4, sound estat & 8
//reser estat & 0x10,  date estat & 0x40, alarm estat & 0x20, dsclk estat & 0x80

 __EEPROM_DATA('L','C','D',' ','R','S','4','8');  //0
 __EEPROM_DATA('5',0x0,' ','M','o','d',' ',0x0);
 __EEPROM_DATA('S','1',':',' ','s','n',' ','l');   //16
 __EEPROM_DATA('d',' ','f','r',' ','t','p',0x00);
 __EEPROM_DATA('S','2',':',' ','c','l',' ','d');  //32
 __EEPROM_DATA('t',' ','a','l',' ','r','s',0x00);
 __EEPROM_DATA('S','3',':',0x0,' ',' ','e','w');   //48
 __EEPROM_DATA(0x0,'A','l','a','r','m',':',0x00);
 __EEPROM_DATA('T','i','m','e',':',' ','h',' ');  //64
 __EEPROM_DATA('h',' ',':',' ','m',' ','m',0x0);
 __EEPROM_DATA('P','o','U','t','S','t','C','t');   //80
 __EEPROM_DATA('P','a','S','o','N','e',0x0,0x00);
 __EEPROM_DATA('N','M','S','O','E',' ',0x0,0x00);  //96
 __EEPROM_DATA('L','o','w','B','a','t',0x0,0x00);  //104
 __EEPROM_DATA(207, 103, 51, 25, 12, 6,' ',0x00);   //112   baud frekv. 1200, 2400, 4800, 9600,19200
#ifdef DS
 __EEPROM_DATA(0x31,0x30,0x30,0x24,0xC5,0x08,0x0,0x0);   // 120  adr, baud, par, ledlev, estat, vref
#else
 __EEPROM_DATA(0x32,0x30,0x30,0x24,0x05,0x08,0x0,0x0);   // 120  adr, baud, par, ledlev, estat, vref
#endif




void Readeprom(char ei,  char *strx){
  char ch, si=0;
    do{ 
    strx[si]= ch = eeprom_read(ei);
    si++; ei++;
    }while(ch!=0);
}

void Ewrite(){

   eeprom_write(EB,adr); eeprom_write(EB+1,baud); eeprom_write(EB+2,par); eeprom_write(EB+3,ledlev);
   eeprom_write(EB+4,estat);
   Beep(20);
}

void Tset(char *str){
  switch(but){
    case 1: str[1]++; if((str[1]&0x0F)>9) str[1]&=0xF0;
    break;
    case 2: str[1]+=0x10; if(str[1]>0x5F) str[1]&=0x0F;
    break;
    case 4: str[2]++; if((str[2]&0x0F)>9) str[2]&=0xF0;
    break;
    case 8: str[2]+=0x10; if(str[2]>0x2F) str[2]&=0x0F;
    break;
        };
   if (str[2]>=0x24) str[2] = 0;
   str[0]=0;
}

void timBcd(char *str, char tim){
    str[0] = ((tim >> 4)) + 0x30;
    str[1] = (tim&0x0F) + 0x30;
    str[2] = ':';
}

char strBcd(char *str){
   return (str[1]&0x0F) | ((str[0]) << 4);
}



void ParBd(){
    if(par==0x30){TX9 =  RX9 = 0;} else {TX9 = RX9 = 1;};
      SPBRG = eeprom_read(112+baud-0x30);
}

void BatTest(){
    static char per = 0;
    char vr = VRCON;
    char cm = 10;
    TRISA |= 0x02; //RA1 jako vstup
    CMCON = 0x02;  //C2: Vin+ = Vref, Vin- = RA1
    //VRCON = 0xA0 + vref;  //RA2 odpojen, Vref - 1/2 VCC  (Vref=REF/24 * VCC; REF=VRCON(3:0); REF = 12 )
    VRCON = 0x80 + vref;  //RA2 odpojen, Vref - 1/2 VCC  (Vref=(REF/32 + 0,25)* VCC; REF=VRCON(3:0); REF = 8 )
    while(cm)cm--; // delay
    cm= CMCON & 0x80; //C2OUT
    if(!cm && per==0){
        Readeprom(104,&str1[10]);
    }
    per++; if(per>9)per=0; 
    VRCON = vr;
    CMCON = 0x07;  //disable comp.
    TRISA &= 0xFD;  //RA1 jako vstup
    
}

void main(void) {
        
    PORTB = 0;
    PORTA = 0;
    TCS = 1;
    TRISA = 0xA4;
    TRISB = 0xF2;
    CMCON = 0x07;  //comp. disabl.
    OPTION_REG = 0x06;  // internal clk, presc. 128
    T2CON = 0x4E;   //01001110
    PR2 = 249;
    CCP1CON = 0x0C;
    CCPR1L = 0; // zhasnout
    VRCON = 0; // vref = 0
    TMR2IE = 1;
    INTCON=0xC0;

    FEN = 1; //disable freq. input
    tflg=0;
    while(!tflg);
    LCD_Init();

    //-----------------------------------------------------------------------

    Readeprom(0, str1); //vodn text
  
    adr = eeprom_read(EB);
    baud = eeprom_read(EB+1);
    par = eeprom_read(EB+2);
    ledlev = eeprom_read(EB+3); 
    estat = eeprom_read(EB+4);
    vref = eeprom_read(EB+5);

    LCD_Strx(0x80);  //zobraz 1. dek
    
   // Startup();
    LedSet();       //jas podsvcen
    

    TXSTA = 0x40; //   SYNC = 0; TX9 = 1; paritn bit 
    RCSTA = 0xF0; //  RX9 = 1; CREN = 1; SPEN = 1;
    ParBd();
    RCIE = 1;

    T1CON = 0x06; //  TMR1ON = 1; T1CKPS1=0; T1CKPS0=0; TMR1CS = 1; nT1SYNC = 1;

    TMR1IE=1;
    tflg=0;
    TMR2=0; //spust osc (sec = 0)
   
Readeprom(0,  &str2[0]);  //text na 2. dek
    disp=1;

#ifdef DS
    DSRAMRead();
#endif
//----------------------Smycka----------------------------------
    do {
        if (tflg) {
            tflg = 0;
            if(!(but=Switch()))bsw=0;
        if(tsec==1){menu=0; Menu();tsec=0;}
            if(!PORTAbits.RA5){menu++; Menu();  //test tlatka Menu
            #ifdef DS
            if(prewr){DSClWrite(); prewr=0; };
            #endif          
            }

            else if(!bsw && but){
            if(menu==0){astp=1;} //estat&=0xBF; //alarm off
            else if(menu==1)
             {
               bsw=1;           
                estat^=but; LedSet();        
              } //menu==1
            
            else if(menu==2){bsw=1; //asm("bsf _bsw,0");
            estat^=(but<<4);
           
           /*  switch(but){
                case 1:   estat|= 0x10; //run = 0;
                break;
                case 2: estat ^= 0x20;  // alarm
                break;
                case 4: estat ^= 0x40;  //datum
                break;
                case 8:  estat ^= 0x80;  //asm("bsf _estat, 5");//zap - vyp ds1302
                break;
                
            } //switch */
            
                    } // menu==2
            
        else if(menu==3){
            switch(but){
                case 1: Ewrite();
                break;
                case 2: baud++; if(baud>0x34)baud=0x30;  //Baud(); //SPBRG = eeprom_read(104+baud);
                break;
                case 4:  par++; if(par>0x34)par = 0x30; //Parita();
               
                break;               
                case 8:  adr++; if( adr>0x39)adr=0x31;
                break;
               
            }
            ParBd();
        }//menu==3

                else if (menu == 4) {
                    if (but)prewr = 1;
                    Tset(timstr);
#ifdef DS                    
                    if (estat & 0x80) {
                        ShTime(0);
                    }
#endif                     

                } else if (menu == 5) {
                    Tset(alarm);
#ifdef DS
                    DSRAMWrite();
#endif
                };

                Menu();
            }// else if !bsw && but

            if (estat & 0x80) {
                if (menu == 0) {
#ifdef DS                    
                    DSClRead();
#endif                   
                    ShTime(estat & 0x40);
                }
            } else

                Time();

            if (!menu) Tick(estat & 8);
            if (estat & 0x1) Temp();
            if ((estat & 2) && menu == 0) FreqCnt();
#ifdef BAT
            BatTest();
#endif
            if (disp) {
                disp = 0;
                TRISB &= 0x0F;
                LCD_Chr(0x01, CMD);
                TRISB |= 0xF0;
                LCD_Strx(0xC0);
            }
            LCD_Strx(0x80);
            if (estat & 0x20 && timstr[2] == alarm[2] && timstr[1] == alarm[1]) {
                if (!astp) Beep(10);
            } else astp = 0;
        }
        if (rec)RxDisp();

        //  if(mes){SendMes(mes==2? str2 : str1);}
        switch (mes) {
            case '1': SendMes(str1);
                break;
            case '2': SendMes(str2);
                break;
            case '0': //tstr[0]=adr; tstr[1]=baud; tstr[2]=par;
                tstr[0] = (estat & 0x0F) + 0x30;
                tstr[1] = (estat >> 4) + 0x30;
                tstr[2] = ledlev;
                tstr[3] = 0;
                SendMes(tstr);
                break;
            case '3': SendMes(&str1[10]); //teplota
                break;
            default: mes = 0;
                break;



        }

        //  mes=0;
        //  else 

    } while (1);
//-------- konec smyky--------------------------------
} //main

void Menu() {
    char xt;
    char ne = ETXT;
    tsec = 10;
    disp = 1;
    Tick(4);
    switch (menu) {
        case 1: //
            str2[16] = 0;
            if (!bsw) for (xt = 0; xt < 17; xt++, ne++) eeprom_write(ne, str2[xt]);
            xt = 16;  //ulozi 2. radek do EEPROM
            break;
        case 2: xt = 32;
            break;
        case 3: xt = 48;
            break;
        case 4: xt = 64;
            break;
        case 5: xt = 57;
            break;
        default: menu = 0;
            xt = ETXT;
            tsec = 0;
            break;
    }

    Readeprom(xt, str2); //LCD_Strx(1);  //nacte z EEPROM 2. radek
    if (menu == 1) {
        if (estat & 8)str2[4] &= 0xDF; //to upper
        if (estat & 4)str2[7] &= 0xDF;
        if (estat & 2)str2[10] &= 0xDF;
        if (estat & 1)str2[13] &= 0xDF;
    } else if (menu == 2) {
        if (estat & 0x80)str2[4] &= 0xDF;
        if (estat & 0x40)str2[7] &= 0xDF;
        if (estat & 0x20)str2[10] &= 0xDF;
    } else if (menu == 3) {
        str2[3] = adr;
        str2[4] = str2[6] = 0x20;
        str2[5] = eeprom_read(par + 96 - 0x30);

        utoa(&str2[7], 12 << (baud - 0x30), 10); //baud

        if (str2[9] == 0) str2[9] = 0x20;
        Readeprom(52, &str2[10]);
        //  str2[6] = tstr[1];
        //  str2[7] = 0;

    } else if (menu == 5) {
        str2[6] = 0x20;
        timBcd(&str2[7], alarm[2]);
        //   str2[9] = ':';
        timBcd(&str2[10], alarm[1]);
        str2[12] = 0;
    };

} // Menu

void Temp() { //nacteni teploty z TC77
    unsigned tem = 0;
    TRISB &= 0x7F;
    TCLK = 1;
    TCS = 0; //cs
    for (char i = 0; i < 13; i++) {
        tem <<= 1;

        TCLK = 0;
        asm("NOP");
        asm("NOP");
        TCLK = 1;
        asm("NOP");
        asm("NOP");
        if (TDAT) {
            tem++;
        }
        //  tem |= TDAT;
    }

    tem += 0x8;
    TCS = 1; //cs
    TRISB |= 0xF0;

    utoa(tstr, ((tem << 3) + (tem << 1)) / 16, 10);

    /*
          dec = strlen(str) - 1;
            st[1] = str[dec];
            str[dec] = 0;
            if ((str[0] == '-' && str[1] == 0) || (str[0] == 0)) strcat(str, "0");
            strcat(str, st);
     */
    str1[16] = str1[9] = 0x20;
    str1[10] = tstr[0];
    str1[11] = tstr[1];
    str1[12] = '.';

    str1[14] = ''; //0xF8;
    str1[15] = 'C';
    str1[17] = 0;
    str1[13] = tstr[2];
}

void interrupt myIsr(void) {

    if (TMR2IF) {
        if (tf == 1) { 
            FEN = 0;   //enable gate
            asm("NOP");
            TMR1ON = 1; //otevre Tmr1
        } else if (tf == 41) {
            TMR1ON = 0; // zavre Tmr1
            FEN = 1;   //disable  gate
            
            asm("bsf _tflg,0");
        };
        TMR2IF = 0;
        tf++;
        if (tf == 100) {
            tf = 0;
            if (tsec)tsec--;
        }
        if (tms)tms--;
    }
    if (TMR1IF) {
        tup++;
        TMR1IF = 0;
    }

    if ((estat & 0x10) == 0)asm("CLRWDT");

    if (RCIF) {    //obsluha RX
        rx = RCREG;
        if (rec == 0 && (rx != 0 || soh == 1)) {

            if (soh == 0 && rx == 0x02) {
                soh = 1;
                px = 0;
                etx = 0;
            }

            if (soh == 1) {
                strt[px] = rx;
                px++;
                strt[px] = 0;

                if (etx == 0 && rx == 0x03) {
                    etx = px + 2;
                } else if (etx == px) {
                    rec = 1;
                    soh = 0;
                };

                if (px > 36 && rec == 0) {
                    px = soh = etx = 0;
                    
                }
            } //if soh==1
        } //if rec==0
    } //RCIF
}


void SendMes(char *str) {
    char x = 0;
    char ch, pr;
    char mask;
    Delay(10); //40 ms
    mes = 0;
    CREN = 0;  //zavre RX
    PORTAbits.RA3 = 1;
    TXEN = 1;  //otevre TX

    while ((ch = str[x++]) != 0) {
        pr = par & 1;
        mask = 1;
        if (par >= 0x33) {
            while (mask) {
                {
                    if (ch & mask)pr ^= 1;
                    mask <<= 1;
                }
            }
        }
        TX9D = pr;
        TXREG = ch;
        while (TRMT == 0); // ek na odvysl.    
    }
    PORTAbits.RA3 = 0;
    TXEN = 0;  //zavre TX
    CREN = 1;  //otevre RX
    //   Beep(5);
}

void RxDisp() {
    char t, x;
    char gadr = 0, ps = 0;   
    int chsum = 0; //Chsum test
    while (strt[ps] != 0x03) {
        chsum += strt[ps];
        ps++;
    }

    chsum += strt[ps];
    ps++;
    chsum -= strt[ps];
    ps++;
    chsum -= (strt[ps] << 8);
    if (chsum != 0) {
        rec = 0;

        ack[0] = 0x15; //Beep(25);
        SendMes(ack);
        return;
    } // else Beep(5);

    if (strt[1] == 0xFF)gadr = 1;
    if (strt[1] == adr || gadr == 1) {
        if (gadr == 0) {      
            ack[0] = 0x06; //Beep(5);
            SendMes(ack);
        }

        if (strt[2] == 0x0A) {
            t = 0;
            for (x = 3; x < 19; x++) {
                if (strt[x] == 03) break;
                else {
                    str2[t] = strt[x];
                    t++;
                }
            }
            str2[t] = 0; // disp=1; //
            asm("bcf _estat, 6");
            asm("bsf _disp,0");
        }
        if (strt[2] == 0x10) {
            ps = 3;
            while ((ssc = strt[ps]) > 0x40) {

                switch (ssc) {
                    case 'I': adr = strt[ps + 1];
                        par = strt[ps + 2];
                        baud = strt[ps + 3];
                        ParBd();
                        ps += 3;
                        break;
                        //    case 'N':  estat=strt[ps+1]&0x0F; estat |= strt[ps+2]<<4;
                        //    break;
                        //         case ' ': ps++;
                        //         break;
                    case 'R': asm("bsf _estat,4"); //estat|=0x10; // resetasm("bsf _estat,4"); //
                        break;
                    case 's': asm("bcf _estat,3"); //estat &= 0xFD; // sound
                        break;
                    case 'S': asm("bsf _estat,3"); //estat |= 8;
                        break;
                    case 'B': Beep(40);
                        break;
                    case 'a': asm("bcf _estat,5"); //alarm
                        break;
                    case 'A': asm("bsf _estat,5"); //alarm
                        if (strt[ps + 1] > 0x2F && strt[ps + 1] < 0x3A) {
                            alarm[2] = strBcd(&strt[ps + 1]); //(strt[5]&0x0F) | (strt[4] << 4);
                            alarm[1] = strBcd(&strt[ps + 4]); //(strt[8]&0x0F) | (strt[7] << 4);
                            ps += 5;

#ifdef DS
                            DSRAMWrite();
#endif
                        }
                        break;
                    case 'M': mes = strt[ps + 1];
                        ps++;
                        break;
                    case 'Y': Settm();
                        TMR2 = 0; //synchro
                        break;
                    case 'f': asm("bcf _estat,1"); //estat &= 0xFB; // freq
                        break;
                    case 'F': asm("bsf _estat,1"); //estat |= 2;
                        break;
                    case 'c': asm("bcf _estat,7"); //estat &= 0xF7; //ds1302
                        break;
                    case 'C': asm("bsf _estat,7"); //asm("bsf _estat,5"); asm("bsf _disp,0");//estat |= 0x80;
                        break;
                    case 'd': asm("bcf _estat,6"); //estat &= 0xF7; //ds1302
                        break;
                    case 'D': asm("bsf _estat,6");
                        asm("bsf _disp,0"); //estat |= 0x80;
                        break;
                    case 't': asm("bcf _estat,0"); //estat &= 0xEF; // teplota
                        break;
                    case 'T': asm("bsf _estat,0"); //estat |= 0x1;
                        break;
                    case 'l': asm("bcf _estat,2");
                        LedSet(); //estat &= 0xFE;
                        break;
                    case 'L': asm("bsf _estat,2");
                        if (strt[ps + 1] > 0x20 && strt[ps + 1] < 0x40) {
                            ledlev = strt[ps + 1];
                            ps++;
                        }
                        LedSet(); //estat |= 0x4;
                        break;
                    case 'E': Ewrite();
                        break;
                } //switch
                ps++;
            } //while
        } //if 0x10

    }//if strt
    rec = 0; // rx=RCREG; // error=0;
} //end

void Beep(char del) {
#ifdef LM
    char i = (del << 2) + (del << 1); //del*6
    do {
        VRCON = 0xCF;
        Sdelay(20);
        VRCON = 0xE0;
        Sdelay(20);
        i--;
    } while (i > 0);
#else
#ifdef PNP
    VRCON = 0xC1;
    Delay(del);
    VRCON = 0xCF;
#else
    VRCON = 0xCF; //U_A2 = 3,6V
    Delay(del);
    VRCON = 0xE0; //U_A2 = 0V
#endif

#endif
    // bep = 0;
}

void Delay(char dms) { //desitky ms
    tms = dms;
    while (tms);
}

void Sdelay(char dl) {
    TMR0 = 255 - dl; // 1 -> 32us
    while (TMR0 != 0);
}

void Tick(char sound) {
    static char tck = 0x20;

    if (sound) {

#ifdef LM
        VRCON = 0xE9;
        Sdelay(sound == 4 ? 0x10 : tck); //__delay_ms(2);
        VRCON = 0xE0; //pro LM386
#else
#ifdef PNP
        VRCON = 0xC4;
        Sdelay(sound == 4 ? 0x10 : tck); //__delay_ms(2);
        VRCON = 0xCF;
#else
        VRCON = 0xCF;
        Sdelay(sound == 4 ? 0x10 : tck); //__delay_ms(2);
        VRCON = 0xE0;
#endif
#endif   
        tck ^= 0x60;
    }
}

void Settm() {

    timstr[7] = 0;

    timstr[6] = strBcd(&strt[19]); //   timstr[6] = (strt[20]&0x0F) | ((strt[19]) << 4);

    timstr[5] = strt[22]&0x0F; //nebo 22!!!!!! je-li mezera ped dnem

    timstr[4] = strBcd(&strt[16]); //strt[17]&0x0F | ((strt[16]&0x01) << 4);

    timstr[3] = strBcd(&strt[13]); //strt[14]&0x0F | ((strt[13]&0x03) << 4);

    timstr[2] = strBcd(&strt[4]); //(strt[5]&0x0F) | ((strt[4]) << 4);

    timstr[1] = strBcd(&strt[7]); //(strt[8]&0x0F) | ((strt[7]) << 4);

    timstr[0] = strBcd(&strt[10]); //(strt[11]&0x0F) | ((strt[10]) << 4);

#ifdef DS
    if (estat & 0x80)DSClWrite();
#endif
    disp = 1; //asm("bsf _disp,0");
}

void Time() {

    // sec++;
    if ((timstr[0]&0x0F) == 10) {
        timstr[0] &= 0xF0;
        timstr[0] += 0x10;
        if (timstr[0] >= 0x60) {
            timstr[0] &= 0x0F;
            timstr[1]++;
            if ((timstr[1]&0x0F) == 10) {
                timstr[1] &= 0xF0;
                timstr[1] += 0x10;
                if (timstr[1] >= 0x60) {
                    timstr[1] &= 0x0F;
                    timstr[2]++;
                    if ((timstr[2]&0x0F) == 10) {
                        timstr[2] &= 0xF0;
                        timstr[2] += 0x10;
                    }
                    if (timstr[2] >= 0x24) timstr[2] = 0;
                }
            }
        }
    }

    ShTime(0);
    timstr[0]++;
    // Tick();
}

void ShTime(char date) {
    timBcd(&str1[0], timstr[2]);
    //   str1[2] = ':';
    timBcd(&str1[3], timstr[1]);
    //   str1[5] = ':';
    timBcd(&str1[6], timstr[0]);
    str1[8] = 0x20;
    str1[9] = 0;
    if (date) {
        if ((timstr[0]/* + timstr[1] + timstr[2]*/) == 0) asm("bsf _disp,0");

        char dt = ((timstr[5]&0x07) << 1) + 78;  //den v tdnu
        str2[0] = str2[3] = 0x20;
        str2[1] = eeprom_read(dt);
        str2[2] = eeprom_read(dt + 1);

        timBcd(&str2[4], timstr[3]);

        timBcd(&str2[7], timstr[4]);
      
        str2[9] = str2[6] = '.';
        str2[10] = '2';
        str2[11] = '0';
        timBcd(&str2[12], timstr[6]);
        str2[14] = 0;
    }
}

void LedSet() {
    CCPR1L = estat & 4 ? ((ledlev - 0x20) << 3) : 0;
}

/*
void Startup() {
    CCPR1L = 0;
    // PWM na RB3  --------------
    if (estat & 4) {
        for (char x = 0; x < 255; x++) {
            Delay(1); //  __delay_ms(10);
            CCPR1L = x;
        }

        for (char x = 255; x > ledlev; x--) {
            Delay(1); // __delay_ms(10);
            CCPR1L = x;
        }
    } else Delay(200);
    //  LedSet();
    Readeprom(10, 9, str1);
    sw = Switch();
    str1[14] = 0x20;
    str1[16] = 0;
    str1[15] = 0;
    if (sw > 9) {
        str1[14] = 0x31;
        str1[15] = sw - 10 + 0x30;
    } else str1[14] = sw + 0x30;

    tflg = 0;
    TMR2 = 0;
    while (!tflg);
    LCD_Strx(0x80);

    while (Switch()); //cek na pusten tlacitek

}*/

char Switch() {

    return (PORTB >> 4)^0x0F;
}

void FreqCnt() {
    //  unsigned long tmr = 0;
    unsigned long tml, tmh;
    char len = 0;
    tml = TMR1L;
    tmh = TMR1H;
    tmrup = tup;
    //  tmr = (tml + (tmh<<8) + (tmrup<<16)) ;
    tml += ((tmh << 8) + (tmrup << 16));
    TMR1L = TMR1H = tup = 0;
    if (tml > 100) {
        ultoa(str2, tml >> 2, 10);

        while (str2[len] != 0)len++;

        if (len > 1) {
            //    if(len==2){len++; str2[0]='0';}

            str2[len] = str2[len - 1];

            str2[len - 1] = str2[len - 2];

            if (tml & 2)str2[len + 1] = '5';
            else str2[len + 1] = '0';

            str2[len + 2] = 0x20;
            if (len > 2) {
                str2[len - 2] = '.';
                str2[len + 3] = 'k';
            } else {
                str2[len - 2] = 0x20;
                str2[len + 3] = 0x20;
            }
            str2[len + 4] = 'H';
            str2[len + 5] = 'z';
            //   Readeprom(101,&str2[len+4]);

            str2[len + 6] = 0;
            // strcat(str2, kstr );
        }
    } else {
        str2[0] = '0';
        str2[1] = 0;
    }
    // asm("bsf _disp,0");

    disp = 1;
}
#ifdef DS

char DSin() {
    char dsr = 0;
    TRISB |= 0x20; //B4 out,  B5 in
    for (char i = 0; i < 8; i++) {
        dsr >>= 1;
        if (DAT == 1)dsr |= 0x80;
        SCLK = 1; //SCLK
        asm("NOP");
        asm("NOP");
        SCLK = 0; //SCLK
        asm("NOP");
        asm("NOP");
    }
    return dsr;
}

void DSout(char reg) {
    for (char i = 0; i < 8; i++) {
        //if(reg&1==1)DAT = 1;
        //else DAT = 0;
        DAT = reg & 1;
        SCLK = 1; //SCLK
        asm("NOP");
        asm("NOP");
        SCLK = 0; //SCLK
        reg >>= 1;
        asm("NOP");
        asm("NOP");
    }
}

void DSWrite(char reg, char dat) {
    TRISB &= 0xCF; //B4 a B5 out
    SCLK = 0; //SCLK
    CEN = 1; //CE hi
    DSout(reg);
    DSout(dat);
    CEN = 0; //CE lo
    TRISB |= 0x30;
}

char DSRead(char reg) {
    TRISB &= 0xCF; //B4 a B5 out
    SCLK = 0; //SCLK
    CEN = 1; //CE hi
    DSout(reg);
    reg = DSin();
    CEN = 0; //CE lo
    TRISB |= 0x30;
    return reg;
}

void DSRAMRead() {
    TRISB &= 0xCF;
    SCLK = 0;
    CEN = 1;
    DSout(0xFF);
    for (char i = 0; i < 4; i++) {
        alarm[i] = DSin();
    }
    CEN = 0;
    TRISB |= 0x30;

}

void DSClRead() {
    TRISB &= 0xCF;
    SCLK = 0;
    CEN = 1;
    DSout(0xBF);
    for (char i = 0; i < 8; i++) {
        timstr[i] = DSin();
    }
    CEN = 0;
    TRISB |= 0x30;
}

void DSRAMWrite() {
    TRISB &= 0xCF;
    SCLK = 0;
    CEN = 1;
    DSout(0xFE);
    for (char i = 0; i < 4; i++) {
        DSout(alarm[i]);
    }
    CEN = 0;
    TRISB |= 0x30;

}

void DSClWrite() {
    TRISB &= 0xCF;
    SCLK = 0;
    CEN = 1;
    DSout(0xBE);
    for (char i = 0; i < 8; i++) {
        DSout(timstr[i]);
    }
    CEN = 0;
    TRISB |= 0x30;
}
#endif
/*
void toBCD(int16 val,int8 * buff) {
   //converts 16bit value, to five BCD digits. Tries to do it fairly
   //efficiently, both in size, and speed.
   int1 temp_bit;
   int8 nibctr;
   buff[0]=buff[1]=buff[2]=0;
   do {
      if ((buff[0] & 0xF)>=5) buff[0]+=3;
      if ((buff[0] & 0xF0)>=0x50) buff[0]+=0X30;
      if ((buff[1] & 0xF)>=5) buff[1]+=3;
      if ((buff[1] & 0xF0)>=0x50) buff[1]+=0X30;
      if ((buff[2] & 0xF)>=5) buff[2]+=3;
      temp_bit=shift_left(&val,2,0);
      shift_left(buff,3,temp_bit);
   } while (val!=0);
}
 */
